import 'dart:convert';

import 'package:modular_system_core/modular_system_core.dart';

class Address implements JsonSerializer<Address> {
  Address();

  factory Address.fromJson(Map<String, dynamic> jsonMap) {
    var i = Address();
    i.isSet = jsonMap["isSet"];
    i.country = jsonMap["country"];
    i.state = jsonMap["state"];
    i.city = jsonMap["city"];
    i.neighborhood = jsonMap["neighborhood"];
    i.streetName = jsonMap["streetName"];
    i.streetNumber = jsonMap["streetNumber"];
    i.zipCode = jsonMap["zipCode"];
    return i;
  }

  bool isSet = false;
  String country = "";
  String state = "";
  String city = "";
  String neighborhood = "";
  String streetName = "";
  String streetNumber = "";
  String zipCode = "";

  String toString() => toFullAddressNational();
  String toFullAddress() =>
      "$streetName, $streetNumber - $neighborhood, $city - $state, $zipCode - $country";
  String toFullAddressLocal([bool showZipCode = false]) =>
      "$streetName, $streetNumber - $neighborhood" +
      (showZipCode ? ", $zipCode" : "");
  String toFullAddressState([bool showZipCode = false]) =>
      "$streetName, $streetNumber - $neighborhood, $city" +
      (showZipCode ? " - $zipCode" : "");
  String toFullAddressNational([bool showZipCode = false]) =>
      "$streetName, $streetNumber - $neighborhood, $city - $state" +
      (showZipCode ? ", $zipCode" : "");

  @override
  Address fromJson(Map<String, dynamic> jsonMap) {
    var i = Address();
    i.isSet = jsonMap["isSet"];
    i.country = jsonMap["country"];
    i.state = jsonMap["state"];
    i.city = jsonMap["city"];
    i.neighborhood = jsonMap["neighborhood"];
    i.streetName = jsonMap["streetName"];
    i.streetNumber = jsonMap["streetNumber"];
    i.zipCode = jsonMap["zipCode"];
    return i;
  }

  @override
  Map<String, dynamic> toJsonMap() {
    var map = {
      'isSet': isSet,
      'country': country,
      'state': state,
      'city': city,
      'neighborhood': neighborhood,
      'streetName': streetName,
      'streetNumber': streetNumber,
      'zipCode': zipCode
    };
    return map;
  }

  @override
  String toJson() => jsonEncode(toJsonMap());
}
